import alice.tuprolog.Number;
import alice.tuprolog.Prolog;
import alice.tuprolog.SolveInfo;

public class BorderSensor {
    Prolog environment;
    public BorderSensor(Prolog environment) {
        this.environment = environment;
    }
    public boolean atBorders(int x, int y) throws Exception {
        if (x == 1) {
            String query = "max_y(P), T is P mod 2, T == 0, P = " + y + ".";
            return environment.solve(query).isSuccess();
        } else {
            String goal = "max_y(P), T is P mod 2, T = 1, max_x(Q), X = Q, P = " + y + ".";
            SolveInfo query = environment.solve(goal);
            if (!query.isSuccess())
                return false;
            Number ex = (Number) query.getVarValue("X");
            return x == ex.intValue();
        }
    }
    public int maxX() throws Exception {
        String goal = "max_x(X).";
        SolveInfo query = environment.solve(goal);
        return ((Number) query.getVarValue("X")).intValue();
    }
    public int maxY() throws Exception {
        String goal = "max_y(Y).";
        SolveInfo query = environment.solve(goal);
        return ((Number) query.getVarValue("Y")).intValue();
    }
}