import alice.tuprolog.Prolog;
import alice.tuprolog.Struct;
import alice.tuprolog.Theory;
import alice.tuprolog.lib.JavaLibrary;

import java.io.File;
import java.io.FileInputStream;

public class CleanerSystem {
    public static void main(String[] args) throws Exception {
        Prolog environment = new Prolog();
        environment.setTheory(new Theory(new FileInputStream(new File("environment.pl"))));
        FilthSensor filthSensor = new FilthSensor(environment);
        BorderSensor borderSensor = new BorderSensor(environment);
        VacuumCleaner cleaner = new VacuumCleaner(environment);
        Prolog agent = new Prolog();
        agent.setTheory(new Theory(new FileInputStream(new File("cleaner.pl"))));
        // register artifacts within agent
        JavaLibrary javaLibrary = (JavaLibrary) agent.getLibrary("alice.tuprolog.lib.JavaLibrary");
        javaLibrary.register(new Struct("filth_sensor"), filthSensor);
        javaLibrary.register(new Struct("border_sensor"), borderSensor);
        javaLibrary.register(new Struct("cleaner"), cleaner);
        // initialize agent in the system
        agent.solve("start.");
        // should return true if everything works
        System.out.println(!environment.solve("dirt(_,_).").isSuccess());
    }
}
