import alice.tuprolog.Prolog;
import alice.tuprolog.Struct;
import alice.tuprolog.Theory;
import alice.tuprolog.lib.JavaLibrary;

import java.io.File;
import java.io.FileInputStream;

public class ThermostatSystem {
    public static void main(String[] args) throws Exception {
        Prolog environment = new Prolog();
        environment.setTheory(new Theory("temp(25)."));
        TemperatureSensor sensor = new TemperatureSensor(environment);
        TemperatureActuator actuator = new TemperatureActuator(environment);
        Prolog agent = new Prolog();
        agent.setTheory(new Theory(new FileInputStream(new File("thermostat.pl"))));
        // register artifacts within agent
        JavaLibrary javaLibrary = (JavaLibrary) agent.getLibrary("alice.tuprolog.lib.JavaLibrary");
        javaLibrary.register(new Struct("sensor"), sensor);
        javaLibrary.register(new Struct("actuator"), actuator);
        // initialize agent in the system
        agent.solve("start.");
        // should return 21 if everything works
        System.out.println(environment.solve("temp(X).").getVarValue("X"));
    }
}
