import alice.tuprolog.Prolog;
import alice.tuprolog.Struct;
import alice.tuprolog.Theory;
import alice.tuprolog.lib.JavaLibrary;

import java.io.File;
import java.io.FileInputStream;

public class ThermostatSystem {
    public static void main(String[] args) throws Exception {
        Prolog environment = new Prolog();
        environment.setTheory(new Theory("temp(25)."));
        TemperatureSensor sensor = new TemperatureSensor(environment);
        TemperatureActuator actuator = new TemperatureActuator(environment);

        final ThermostatAgent thermostatAgent = new ThermostatAgent();
        TemperatureAgent temperatureAgent = new TemperatureAgent();
        // register artifacts within agents
        thermostatAgent.registerArtifact("actuator", actuator);

        temperatureAgent.registerArtifact("sensor", sensor);
        temperatureAgent.registerArtifact("actuator", actuator);

        // initialize agent in the system
        new Thread() {
			public void run() {
				thermostatAgent.start();
			}
		}.start();
        temperatureAgent.start();
    }
}
